import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner

class MainTest(unittest.TestCase):

    def test_answer(self):
        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        for n in range(0, 10000):
            main()
        sys.stdout = sys.__stdout__ 

        output = list(capturedOutput.getvalue().strip().split("\n"))

        dogsCount = output.count('I love dogs')
        catsCount = output.count('I love cats')
        batsCount = output.count('I love bats')

        # Check if output format is correct (for ex plural forms)
        self.assertGreater(dogsCount, 0, "Your output doesn't have the statement 'I love dogs'.")
        self.assertGreater(catsCount, 0, "Your output doesn't have the statement 'I love cats'.")
        self.assertGreater(batsCount, 0, "Your output doesn't have the statement 'I love bats'.")


        self.assertGreaterEqual(dogsCount, 7850, "Too few dogs?")
        self.assertLessEqual(dogsCount, 8147, "Too many dogs?")    

        self.assertGreaterEqual(catsCount, 890, "Too few cats?") 
        self.assertLessEqual(catsCount, 1113, "Too many cats?")

        # Already being tested above
        # self.assertGreater(batsCount, 0, "Too few bats?")

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())