import unittest, sys
import io
import unittest.mock

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'main')

class MainTest(unittest.TestCase):
   
    @points('1-4')
    def test_answer(self):
        for n in range(0, 10000):
            main()
        
        output = list(get_out().split("\n"))

        dogsCount = output.count('I love dogs')
        catsCount = output.count('I love cats')
        batsCount = output.count('I love bats')

        # Check if output format is correct (for ex plural forms)
        self.assertGreater(dogsCount, 0, "Your output doesn't have the statement 'I love dogs'.")
        self.assertGreater(catsCount, 0, "Your output doesn't have the statement 'I love cats'.")
        self.assertGreater(batsCount, 0, "Your output doesn't have the statement 'I love bats'.")


        self.assertGreaterEqual(dogsCount, 7850, "Too few dogs?")
        self.assertLessEqual(dogsCount, 8147, "Too many dogs?")    

        self.assertGreaterEqual(catsCount, 890, "Too few cats?") 
        self.assertLessEqual(catsCount, 1113, "Too many cats?")

        # Already being tested above
        # self.assertGreater(batsCount, 0, "Too few bats?")


if __name__ == '__main__':
    unittest.main()
